@using Entities
@using Business
@using DataAccess;

@inject IDbContextFactory<inventory_context> ContextFactory
@inject NavigationManager navManager

<h4>Editar Información del Producto</h4>


@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<EditForm Model="oProduct">

    <div class="form-group">
        <label for="">Product:</label>
        <InputText class="form-control" @bind-Value="oProduct.ProdName" />
    </div>
    <br>

    <div class="form-group">
        <label for="">Código del Producto:</label>
        <InputText class="form-control" @bind-Value="oProduct.ProdCode" />
    </div>
    <br>

    <div class="form-group">
        <label for="">Descripción:</label>
        <InputTextArea class="form-control" @bind-Value="oProduct.ProdDescription" />
    </div>
    <br>

    <div class="form-group">
        <label for="">Actualizar Categoría:</label>
        <InputSelect @bind-Value="oProduct.CatId" class="form-control">
            @foreach (var category in categories)
            {
                <option value="none" selected disabled hidden>Elige una Categoria ..</option>
                <option value="@category.CatId">@category.CatName</option>
            }
        </InputSelect>
    </div>
    <br>





    <input type="button" value="Actualizar Producto" @onclick="UpdateProduct">

</EditForm>


@code
{
    [Parameter] public string ParamProdId { get; set; } = string.Empty;

    
    private bool DataLoading = false;
    private string loading_message = "Fetching products from DB ...";
    Product oProduct = new();
    List<Category> categories = new();
    B_Category bCategory = null!;
    B_Product bProduct = null!;

    protected override async Task OnInitializedAsync()
    {
        if (DataLoading) 
        {
            return;
        }
        try
        {
            DataLoading = true;
            
            bCategory = new(ContextFactory);
            bProduct = new(ContextFactory);

            if (bCategory is not null)
            {
                categories = await bCategory.GetCategories();
                oProduct = await bProduct.GetProductById(int.Parse(ParamProdId));
            }
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }

        await base.OnInitializedAsync();
    }

    private async Task UpdateProduct()
    {
        await bProduct.UpdateProduct(oProduct);

        navManager.NavigateTo("products/list");
    }
}